#include "ovdisis.h"

int gem2tos_2bpl[4]  = { 0,3,1,2 };
int gem2tos_4bpl[16] = { 0,15,1,2,4,6,3,5,7,8,9,10,12,14,11,13 };
int tos2gem_2bpl[4]  = { 0,2,3,1 };
int tos2gem_4bpl[16] = { 0,2,3,6,4,7,5,8,9,10,11,14,12,15,13,1 };

static void fix_linex(RECT *);
static void fix_liney(RECT *);
void fix_rect(RECT *);

/* inline? Could be made as a #define! */
int do_pointclip(int x, int y, RECT *clip)
{
  if((x < clip->x1) || (x > clip->x2) ||
     (y < clip->y1) || (y > clip->y2))
    return 0;
  else
    return 1;
}

int do_rectclip(RECT *cor, RECT *clip)
{
  fix_rect(cor);

  if(((cor->x1 < clip->x1) && (cor->x2 < clip->x1)) ||
     ((cor->x1 > clip->x2) && (cor->x2 > clip->x2)) ||
     ((cor->y1 < clip->y1) && (cor->y2 < clip->y1)) ||
     ((cor->y1 > clip->y2) && (cor->y2 > clip->y2)))
    return 0;

  cor->x1 = max(cor->x1, clip->x1);
  cor->y1 = max(cor->y1, clip->y1);
  cor->x2 = min(cor->x2, clip->x2);
  cor->y2 = min(cor->y2, clip->y2);

  return 1;
}

/* This HAS to be possible in a more simple way! */
/* Hmm, maybe not. */
int do_lineclip(RECT *cor, RECT *clip)
{
  fix_linex(cor);

  /* check if totally out of it */
  if(((cor->x1 < clip->x1) && (cor->x2 < clip->x1)) ||
     ((cor->x1 > clip->x2) && (cor->x2 > clip->x2)) ||
     ((cor->y1 < clip->y1) && (cor->y2 < clip->y1)) ||
     ((cor->y1 > clip->y2) && (cor->y2 > clip->y2)))
    return 0;

  if(cor->x1 == cor->x2)
    { /* Vertical line */
      if(cor->y1 < clip->y1)
	{
	  if(cor->y2 < clip->y1)
	    return 0;
	  else
	    {
	      cor->y1 = clip->y1;
	      cor->y2 = min(cor->y2, clip->y2);
	    }
	}
      else
	{
	  if(cor->y1 > clip->y2)
	    return 0;
	  else
	    cor->y2 = min(cor->y2, clip->y2);
	}
    }
  else if(cor->y1 == cor->y2)
    { /* Horizontal line */
      if(cor->x1 < clip->x1)
	{
	  if(cor->x2 < clip->x1)
	    return 0;
	  else
	    {
	      cor->x1 = clip->x1;
	      cor->x2 = min(cor->x2, clip->x2);
	    }
	}
      else
	{
	  if(cor->x1 > clip->x2)
	    return 0;
	  else
	    cor->x2 = min(cor->x2, clip->x2);
	}
    }
  else
    { /* Non straight line */
      int t1,t2;
      double kx,ky;

      /* Check again if outside */
      fix_liney(cor);
      ky = ((double)(cor->x2 - cor->x1) / (double)(cor->y2 - cor->y1));
      t1 = cor->x1 - (int)((double)(cor->y1 - clip->y1) * ky);
      t2 = cor->x2 - (int)((double)(cor->y2 - clip->y2) * ky);
      if(((t1 > clip->x2) && (t2 > clip->x2)) ||
	 ((t1 < clip->x1) && (t2 < clip->x1)))
	return 0;

      fix_linex(cor);
      kx = ((double)(cor->y2 - cor->y1) / (double)(cor->x2 - cor->x1));
      t1 = cor->y1 - (int)((double)(cor->x1 - clip->x1) * kx);
      t2 = cor->y2 - (int)((double)(cor->x2 - clip->x2) * kx);
      if(((t1 > clip->y2) && (t2 > clip->y2)) ||
	 ((t1 < clip->y1) && (t2 < clip->y1)))
	return 0;


      if(cor->x1 < clip->x1)
	{
	  cor->y1 += (int)((double)(clip->x1 - cor->x1) * kx);
	  cor->x1 = clip->x1;
	}
      if(cor->y1 < clip->y1)
	{
	  cor->x1 += (int)((double)(clip->y1 - cor->y1) * ky);
	  cor->y1 = clip->y1;
	}
      else if(cor->y1 > clip->y2)
	{
	  cor->x1 += (int)((double)(clip->y2 - cor->y1) * ky);
	  cor->y1 = clip->y2;
	}
      
      if(cor->x2 > clip->x2)
	{
	  cor->y2 += (int)((double)(clip->x2 - cor->x2) * kx);
	  cor->x2 = clip->x2;
	}
      if(cor->y2 > clip->y2)
	{
	  cor->x2 += (int)((double)(clip->y2 - cor->y2) * ky);
	  cor->y2 = clip->y2;
	}
      else if(cor->y2 < clip->y1)
	{
	  cor->x2 += (int)((double)(clip->y1 - cor->y2) * ky);
	  cor->y2 = clip->y1;
	}

    }
  return 1;
}

void fix_rect(RECT *cor)
{
  RECT t;

  t.x1 = min(cor->x1, cor->x2);
  t.y1 = min(cor->y1, cor->y2);
  cor->x2 = max(cor->x1, cor->x2);
  cor->y2 = max(cor->y1, cor->y2);
  cor->x1 = t.x1;
  cor->y1 = t.y1;
}

void fix_linex(RECT *cor)
{
  int t;

  if(cor->x2 < cor->x1)
    {
      t = cor->x1;
      cor->x1 = cor->x2;
      cor->x2 = t;
      t = cor->y1;
      cor->y1 = cor->y2;
      cor->y2 = t;
    }
}

void fix_liney(RECT *cor)
{
  int t;

  if(cor->y2 < cor->y1)
    {
      t = cor->y1;
      cor->y1 = cor->y2;
      cor->y2 = t;
      t = cor->x1;
      cor->x1 = cor->x2;
      cor->x2 = t;
    }
}


/* Used by v_circle. Puts pixels around the circle */
void set_circle_pixels(FB *fb, int x, int y, int xc, int yc, RECT *clip, int col)
{
  if(do_pointclip(xc + x, yc + y, clip))
    FBputpixel(fb, xc + x, yc + y, col);
  if(do_pointclip(xc - x, yc + y, clip))
    FBputpixel(fb, xc - x, yc + y, col);
  if(do_pointclip(xc + x, yc - y, clip))
    FBputpixel(fb, xc + x, yc - y, col);
  if(do_pointclip(xc - x, yc - y, clip))
    FBputpixel(fb, xc - x, yc - y, col);
  if(do_pointclip(xc + y, yc + x, clip))
    FBputpixel(fb, xc + y, yc + x, col);
  if(do_pointclip(xc - y, yc + x, clip))
    FBputpixel(fb, xc - y, yc + x, col);
  if(do_pointclip(xc + y, yc - x, clip))
    FBputpixel(fb, xc + y, yc - x, col);
  if(do_pointclip(xc - y, yc - x, clip))
    FBputpixel(fb, xc - y, yc - x, col);
}

/* Used by v_circle. Puts calculated
   x values in lists ordered by the
   y value. Used for filling */
/* Might be better as #define or inline */
void list_circle_points(int x, int y, int radius, int *x_values)
{
  /* Only save one quarter of the circle, the
     rest is mirrored when drawing */

  x_values[-y+radius] = max(x_values[-y+radius], x);        /* x, -y */
  x_values[-x+radius] = max(x_values[-x+radius], y);        /* y, -x */
}



/* inlines? */
int gem2tos_color(int nbpl, int index)
{
  switch(nbpl)
    {
    case 1:
      return ((unsigned int)index<1 ? index : 1);
    case 2:
      return ((unsigned int)index<4 ? gem2tos_2bpl[index] : 3);
    case 4:
      return ((unsigned int)index<16 ? gem2tos_4bpl[index] : 15);
    case 8:
      return ((unsigned int)index<16 ? gem2tos_4bpl[index] : index);
    default:
      return index;
    }
}

int tos2gem_color(int nbpl, int index)
{
  switch(nbpl)
    {
    case 1:
      return ((unsigned int)index<1 ? index : 1);
    case 2:
      return ((unsigned int)index<4 ? tos2gem_2bpl[index] : 3);
    case 4:
      return ((unsigned int)index<16 ? tos2gem_4bpl[index] : 15);
    case 8:
      return ((unsigned int)index<16 ? tos2gem_4bpl[index] : index);
    default:
      return index;
    }
}


