#include <stdio.h>

#include "ovdisis.h"
#include "various.h"

void vdi_vs_color(VDI_Workstation *vwk)
{
  int i;

  i = gem2tos_color(vwk->planes, vdipb->intin[0]);
  /* Have to check what should happen if
     color is out of range */
  if(i >= vwk->colors)
    {
      EDEBUG("vs_color: Color index %d out of range!\n",vdipb->intin[0]);
      return;
    }

  vwk->fb->cmap->red[i]   = (unsigned short)((vdipb->intin[1] * 65535) / 1000);
  vwk->fb->cmap->green[i] = (unsigned short)((vdipb->intin[2] * 65535) / 1000);
  vwk->fb->cmap->blue[i]  = (unsigned short)((vdipb->intin[3] * 65535) / 1000);

  vwk->fb->cmap->start = i;
  vwk->fb->cmap->end   = i;
  vwk->fb->cmap->len   = 1;
  ADEBUG("vs_color: Putting cmap (%lx) in framebuffer (%lx)\n",
	 (unsigned long)vwk->fb->cmap, (unsigned long)vwk->fb);
  FBputcmap(vwk->fb, vwk->fb->cmap);

  ADEBUG("vs_color: Vdi color %d is set to: %u, %u, %u\n",
	 vdipb->intin[0],vdipb->intin[1],vdipb->intin[2],vdipb->intin[3]);
  ADEBUG("vs_color: Which means cmap color %d is set to: %u, %u, %u\n",
	 i, vwk->fb->cmap->red[i], vwk->fb->cmap->green[i], vwk->fb->cmap->blue[i]);
}

void vdi_vq_color(VDI_Workstation *vwk)
{
  int i;

  if(vdipb->intin[0] > vwk->colors)
    vdipb->intout[0] = -1;    /* Color out of range */
  else
    {
      i = gem2tos_color(vwk->planes, vdipb->intin[0]);
      vdipb->intout[0] = i;

      /*  vdipb->intin[1] is a flag for something!!!!!!! */

      vdipb->intout[1] = (short)((vwk->fb->cmap->red[i]   * 1000) / 65535);
      vdipb->intout[2] = (short)((vwk->fb->cmap->green[i] * 1000) / 65535);
      vdipb->intout[3] = (short)((vwk->fb->cmap->blue[i]  * 1000) / 65535);

      ADEBUG("vq_color: Cmap color %d is %u, %u, %u\n",
	     i, vwk->fb->cmap->red[i], vwk->fb->cmap->green[i], vwk->fb->cmap->blue[i]);
      ADEBUG("vq_color: Which means vdi color %d is %u, %u, %u\n",
	     vdipb->intin[0],vdipb->intout[1],vdipb->intout[2],vdipb->intout[3]);
    }

  vdipb->contrl[N_INTOUT] = 4;
}

void vdi_v_get_pixel(VDI_Workstation *vwk)
{
  int ti;

  if((ti = FBgetpixel(vwk->fb, vdipb->ptsin[0], vdipb->ptsin[1])) != 0)
    vdipb->intout[0] = 1;
  else
    vdipb->intout[0] = 0;

  vdipb->intout[1] = tos2gem_color(vwk->planes, ti);

  vdipb->contrl[N_INTOUT] = 2;
}

void vdi_vex_timv(VDI_Workstation *vwk)
{
  EDEBUG("vex_timv: Call not implemented!\n");
}

void vdi_vq_key_s(VDI_Workstation *vwk)
{
  EDEBUG("vq_key_s: Call not implemented!\n");
}

void vdi_vqin_mode(VDI_Workstation *vwk)
{
  EDEBUG("vqin_mode: Call not implemented!\n");
}


